import type { DId } from '../../utils/types';
import type { ComboboxKeyDownRef } from '../_keyboard';
import type { AbstractTreeNode } from '../tree/abstract-node';
import type { DCascaderItem } from './Cascader';
import React from 'react';
export interface DListProps<V extends DId, T extends DCascaderItem<V>> extends Omit<React.HTMLAttributes<HTMLElement>, 'children'> {
    dGetItemId: (value: V) => string;
    dList: AbstractTreeNode<V, T>[];
    dFocusItem: AbstractTreeNode<V, T> | undefined;
    dCustomItem: ((item: T) => React.ReactNode) | undefined;
    dMultiple: boolean;
    dFocusVisible: boolean;
    dRoot: boolean;
    onFocusChange: (node: AbstractTreeNode<V, T>) => void;
    onClickItem: (node: AbstractTreeNode<V, T>) => void;
}
declare function List<V extends DId, T extends DCascaderItem<V>>(props: DListProps<V, T>, ref: React.ForwardedRef<ComboboxKeyDownRef>): JSX.Element | null;
export declare const DList: <V extends DId, T extends DCascaderItem<V>>(props: DListProps<V, T> & React.RefAttributes<ComboboxKeyDownRef>) => ReturnType<typeof List>;
export {};
