var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
import { isNull, isUndefined, nth } from 'lodash';
import React, { useImperativeHandle, useRef, useState } from 'react';
import { useEvent, useId, useRefExtra } from '@react-devui/hooks';
import { findNested, getClassName } from '@react-devui/utils';
import { useDValue } from '../../hooks';
import { registerComponentMate, TTANSITION_DURING_BASE } from '../../utils';
import { EXPANDED_DATA } from '../../utils/checkNoExpandedEl';
import { DFocusVisible } from '../_focus-visible';
import { useNestedPopup } from '../_popup';
import { DCollapseTransition } from '../_transition';
import { useComponentConfig, usePrefixConfig } from '../root';
import { DGroup } from './Group';
import { DItem } from './Item';
import { DSub } from './Sub';
import { checkEnableItem, getSameLevelEnableItems } from './utils';
const { COMPONENT_NAME } = registerComponentMate({ COMPONENT_NAME: 'DMenu' });
function Menu(props, ref) {
    const _a = useComponentConfig(COMPONENT_NAME, props), { dList, dWidth = 'auto', dActive, dExpands, dMode = 'vertical', dExpandOne = false, dExpandTrigger, onActiveChange, onExpandsChange } = _a, restProps = __rest(_a, ["dList", "dWidth", "dActive", "dExpands", "dMode", "dExpandOne", "dExpandTrigger", "onActiveChange", "onExpandsChange"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    //#endregion
    //#region Ref
    const windowRef = useRefExtra(() => window);
    //#endregion
    const dataRef = useRef({
        updatePosition: new Map(),
    });
    const uniqueId = useId();
    const getItemId = (id) => `${dPrefix}menu-item-${id}-${uniqueId}`;
    const [activeId, changeActiveId] = useDValue(null, dActive, (id) => {
        if (onActiveChange) {
            onActiveChange(id, findNested(dList, (item) => item.id === id));
        }
    });
    const activeIds = (() => {
        let ids;
        const reduceArr = (arr, subParent = []) => {
            for (const item of arr) {
                if (ids) {
                    break;
                }
                if (item.children) {
                    reduceArr(item.children, item.type === 'sub' ? subParent.concat([item.id]) : subParent);
                }
                else if (item.id === activeId) {
                    ids = subParent.concat([item.id]);
                }
            }
        };
        if (!isNull(activeId)) {
            reduceArr(dList);
        }
        return ids !== null && ids !== void 0 ? ids : [];
    })();
    const [expandIds, changeExpandIds] = useDValue([], dExpands, (ids) => {
        if (onExpandsChange) {
            let length = ids.length;
            const items = [];
            const reduceArr = (arr) => {
                for (const item of arr) {
                    if (length === 0) {
                        break;
                    }
                    if (item.children) {
                        reduceArr(item.children);
                    }
                    else {
                        const index = ids.findIndex((id) => id === item.id);
                        if (index !== -1) {
                            items[index] = item;
                            length -= 1;
                        }
                    }
                }
            };
            reduceArr(dList);
            onExpandsChange(ids, items);
        }
    });
    const { popupIds, setPopupIds, addPopupId, removePopupId } = useNestedPopup();
    const [focusIds, setFocusIds] = useState([]);
    const [isFocus, setIsFocus] = useState(false);
    const [focusVisible, setFocusVisible] = useState(false);
    const focusId = (() => {
        var _a;
        if (isFocus) {
            if (dMode === 'vertical') {
                return nth(focusIds, -1);
            }
            else {
                let id;
                for (const [index, focusId] of focusIds.entries()) {
                    id = focusId;
                    if (((_a = nth(popupIds, index)) === null || _a === void 0 ? void 0 : _a.id) !== focusId) {
                        break;
                    }
                }
                return id;
            }
        }
    })();
    const initFocus = () => {
        let firstId;
        const ids = [];
        const reduceArr = (arr) => {
            for (const item of arr) {
                if (ids.length === 1) {
                    break;
                }
                if ((item.type === 'group' || (dMode === 'vertical' && item.type === 'sub' && expandIds.includes(item.id))) && item.children) {
                    reduceArr(item.children);
                }
                else if (checkEnableItem(item)) {
                    if (isUndefined(firstId)) {
                        firstId = item.id;
                    }
                    if (activeIds.includes(item.id)) {
                        ids.push(item.id);
                    }
                }
            }
        };
        reduceArr(dList);
        setFocusIds(ids.length === 0 ? (isUndefined(firstId) ? [] : [firstId]) : ids);
    };
    useEvent(windowRef, 'keydown', (e) => {
        if (e.code === 'Escape') {
            setPopupIds([]);
        }
    }, {}, popupIds.length === 0);
    let handleKeyDown;
    const nodes = (() => {
        const getNodes = (arr, level, subParents, inNav = false) => {
            const posinset = new Map();
            let noGroup = [];
            for (const item of arr) {
                if (item.type === 'group') {
                    for (const [i, o] of noGroup.entries()) {
                        posinset.set(o.id, [i, noGroup.length]);
                    }
                    noGroup = [];
                }
                else {
                    noGroup.push(item);
                }
            }
            for (const [i, o] of noGroup.entries()) {
                posinset.set(o.id, [i, noGroup.length]);
            }
            return arr.map((item) => {
                const { id: itemId, title: itemTitle, type: itemType, icon: itemIcon, disabled: itemDisabled = false, children } = item;
                const _subParents = itemType === 'sub' ? subParents.concat([item]) : subParents;
                const id = getItemId(itemId);
                const isExpand = expandIds.includes(itemId);
                const isFocus = itemId === focusId;
                const isEmpty = !(children && children.length > 0);
                const popupState = popupIds.find((v) => v.id === itemId);
                let step = 20;
                let space = 16;
                if (dMode === 'horizontal' && inNav) {
                    space = 20;
                }
                if (dMode !== 'vertical' && !inNav) {
                    step = 12;
                    space = 10;
                }
                const handleItemClick = () => {
                    changeActiveId(itemId);
                    setFocusIds(subParents.map((parentItem) => parentItem.id).concat([itemId]));
                };
                const handleSubExpand = (sameLevelItems) => {
                    if (isExpand) {
                        changeExpandIds((draft) => {
                            const index = draft.findIndex((id) => id === itemId);
                            draft.splice(index, 1);
                        });
                    }
                    else {
                        if (dExpandOne) {
                            const ids = expandIds.filter((id) => sameLevelItems.findIndex((sameLevelItem) => sameLevelItem.id === id) === -1);
                            ids.push(itemId);
                            changeExpandIds(ids);
                        }
                        else {
                            changeExpandIds((draft) => {
                                draft.push(itemId);
                            });
                        }
                    }
                };
                if (isFocus) {
                    handleKeyDown = (e) => {
                        var _a, _b, _c, _d;
                        const sameLevelItems = getSameLevelEnableItems((_b = (_a = nth(subParents, -1)) === null || _a === void 0 ? void 0 : _a.children) !== null && _b !== void 0 ? _b : dList);
                        const focusItem = (val) => {
                            if (val) {
                                setFocusIds(subParents.map((parentItem) => parentItem.id).concat([val.id]));
                            }
                        };
                        const handleOpenSub = () => {
                            if (dMode === 'vertical') {
                                if (!isExpand) {
                                    handleSubExpand(sameLevelItems);
                                }
                            }
                            else {
                                addPopupId(itemId);
                            }
                            if (children) {
                                const newFocusItem = nth(getSameLevelEnableItems(children), 0);
                                if (newFocusItem) {
                                    setFocusIds(_subParents.map((parentItem) => parentItem.id).concat([newFocusItem.id]));
                                }
                            }
                        };
                        if (dMode === 'horizontal' && inNav) {
                            switch (e.code) {
                                case 'ArrowUp':
                                    e.code = 'ArrowLeft';
                                    break;
                                case 'ArrowLeft':
                                    e.code = 'ArrowUp';
                                    break;
                                case 'ArrowDown':
                                    e.code = 'ArrowRight';
                                    break;
                                case 'ArrowRight':
                                    e.code = 'ArrowDown';
                                    break;
                                default:
                                    break;
                            }
                        }
                        switch (e.code) {
                            case 'ArrowUp': {
                                e.preventDefault();
                                const index = sameLevelItems.findIndex((sameLevelItem) => sameLevelItem.id === itemId);
                                const newFocusItem = nth(sameLevelItems, index - 1);
                                focusItem(newFocusItem);
                                if (dMode !== 'vertical' && newFocusItem && ((_c = nth(popupIds, -1)) === null || _c === void 0 ? void 0 : _c.id) === itemId) {
                                    setPopupIds(popupIds.slice(0, -1));
                                }
                                break;
                            }
                            case 'ArrowDown': {
                                e.preventDefault();
                                const index = sameLevelItems.findIndex((sameLevelItem) => sameLevelItem.id === itemId);
                                const newFocusItem = nth(sameLevelItems, (index + 1) % sameLevelItems.length);
                                focusItem(newFocusItem);
                                if (dMode !== 'vertical' && newFocusItem && ((_d = nth(popupIds, -1)) === null || _d === void 0 ? void 0 : _d.id) === itemId) {
                                    setPopupIds(popupIds.slice(0, -1));
                                }
                                break;
                            }
                            case 'ArrowLeft': {
                                e.preventDefault();
                                if (dMode === 'vertical') {
                                    changeExpandIds((draft) => {
                                        const index = draft.findIndex((id) => { var _a; return id === ((_a = nth(subParents, -1)) === null || _a === void 0 ? void 0 : _a.id); });
                                        draft.splice(index, 1);
                                    });
                                }
                                else {
                                    setPopupIds(popupIds.slice(0, -1));
                                }
                                const ids = subParents.map((item) => item.id);
                                if (ids.length > 0) {
                                    setFocusIds(ids);
                                }
                                break;
                            }
                            case 'ArrowRight':
                                e.preventDefault();
                                if (itemType === 'sub') {
                                    handleOpenSub();
                                }
                                break;
                            case 'Home':
                                e.preventDefault();
                                focusItem(nth(sameLevelItems, 0));
                                break;
                            case 'End':
                                e.preventDefault();
                                focusItem(nth(sameLevelItems, -1));
                                break;
                            case 'Enter':
                            case 'Space':
                                e.preventDefault();
                                if (itemType === 'item') {
                                    handleItemClick();
                                }
                                else if (itemType === 'sub') {
                                    handleOpenSub();
                                }
                                break;
                            default:
                                break;
                        }
                    };
                }
                return (_jsx(React.Fragment, { children: itemType === 'item' ? (_jsx(DItem, Object.assign({ dId: id, dLevel: level, dStep: step, dSpace: space, dIcon: itemIcon, dPosinset: posinset.get(itemId), dMode: dMode, dInNav: inNav, dActive: activeId === itemId, dFocusVisible: focusVisible && isFocus, dDisabled: itemDisabled, onItemClick: handleItemClick }, { children: itemTitle }))) : itemType === 'group' ? (_jsx(DGroup, Object.assign({ dId: id, dLevel: level, dStep: step, dSpace: space, dList: children && getNodes(children, level + 1, _subParents), dEmpty: isEmpty }, { children: itemTitle }))) : (_jsx(DSub, Object.assign({ ref: (fn) => {
                            if (isNull(fn)) {
                                dataRef.current.updatePosition.delete(itemId);
                            }
                            else {
                                dataRef.current.updatePosition.set(itemId, fn);
                            }
                        }, dId: id, dLevel: level, dStep: step, dSpace: space, dIcon: itemIcon, dList: children && getNodes(children, dMode === 'vertical' ? level + 1 : 0, _subParents), dPopupState: popupState === null || popupState === void 0 ? void 0 : popupState.visible, dTrigger: dExpandTrigger !== null && dExpandTrigger !== void 0 ? dExpandTrigger : (dMode === 'vertical' ? 'click' : 'hover'), dPosinset: posinset.get(itemId), dMode: dMode, dInNav: inNav, dActive: (dMode === 'vertical' ? !isExpand : isUndefined(popupState)) && activeIds.includes(itemId), dExpand: isExpand, dEmpty: isEmpty, dFocusVisible: focusVisible && isFocus, dDisabled: itemDisabled, onVisibleChange: (visible) => {
                            if (visible) {
                                if (subParents.length === 0) {
                                    setPopupIds([{ id: itemId, visible: true }]);
                                }
                                else {
                                    addPopupId(itemId);
                                }
                            }
                            else {
                                removePopupId(itemId);
                            }
                        }, onSubClick: () => {
                            var _a, _b;
                            if (!itemDisabled) {
                                setFocusIds(subParents.map((parentItem) => parentItem.id).concat([itemId]));
                                if (dMode === 'vertical') {
                                    const sameLevelItems = getSameLevelEnableItems((_b = (_a = nth(subParents, -1)) === null || _a === void 0 ? void 0 : _a.children) !== null && _b !== void 0 ? _b : dList);
                                    handleSubExpand(sameLevelItems);
                                }
                            }
                        } }, { children: itemTitle }))) }, itemId));
            });
        };
        return getNodes(dList, 0, [], true);
    })();
    useImperativeHandle(ref, () => ({
        updatePosition: () => {
            for (const fn of dataRef.current.updatePosition.values()) {
                fn();
            }
        },
    }), []);
    return (_jsx(DCollapseTransition, Object.assign({ dOriginalSize: {
            width: dWidth,
        }, dCollapsedStyle: {
            width: 64,
        }, dIn: dMode !== 'icon', dDuring: TTANSITION_DURING_BASE, dStyles: {
            entering: {
                transition: ['width', 'padding', 'margin'].map((attr) => `${attr} ${TTANSITION_DURING_BASE}ms linear`).join(', '),
            },
            leaving: {
                transition: ['width', 'padding', 'margin'].map((attr) => `${attr} ${TTANSITION_DURING_BASE}ms linear`).join(', '),
            },
        } }, { children: (collapseRef, collapseStyle) => {
            const preventBlur = (e) => {
                if (e.target !== collapseRef.current && e.button === 0) {
                    e.preventDefault();
                }
            };
            return (_jsx(DFocusVisible, Object.assign({ onFocusVisibleChange: setFocusVisible }, { children: ({ render: renderFocusVisible }) => {
                    var _a;
                    return renderFocusVisible(
                    // eslint-disable-next-line jsx-a11y/aria-activedescendant-has-tabindex
                    _jsx("nav", Object.assign({}, restProps, { [EXPANDED_DATA]: popupIds.length > 0 }, { ref: collapseRef, className: getClassName(restProps.className, `${dPrefix}menu`, {
                            [`${dPrefix}menu--horizontal`]: dMode === 'horizontal',
                        }), style: Object.assign(Object.assign(Object.assign({}, restProps.style), { width: dWidth }), collapseStyle), tabIndex: (_a = restProps.tabIndex) !== null && _a !== void 0 ? _a : 0, role: "menubar", "aria-orientation": dMode === 'horizontal' ? 'horizontal' : 'vertical', "aria-activedescendant": isUndefined(focusId) ? undefined : getItemId(focusId), onFocus: (e) => {
                            var _a;
                            (_a = restProps.onFocus) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
                            setIsFocus(true);
                            initFocus();
                        }, onBlur: (e) => {
                            var _a;
                            (_a = restProps.onBlur) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
                            setIsFocus(false);
                            setPopupIds([]);
                        }, onKeyDown: (e) => {
                            var _a;
                            (_a = restProps.onKeyDown) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
                            handleKeyDown === null || handleKeyDown === void 0 ? void 0 : handleKeyDown(e);
                        }, onMouseDown: (e) => {
                            var _a;
                            (_a = restProps.onMouseDown) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
                            preventBlur(e);
                        }, onMouseUp: (e) => {
                            var _a;
                            (_a = restProps.onMouseUp) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
                            preventBlur(e);
                        } }, { children: nodes })));
                } })));
        } })));
}
export const DMenu = React.forwardRef(Menu);
